package com.hp.user.service.redis;

import org.apache.commons.pool2.impl.GenericObjectPoolConfig;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;

@Component
public class RedisOperation implements ApplicationRunner{

    @Value("${redis-cluster.redisUrlList}")
    private String hostAndPort;
    @Value("${redis-cluster.password}")
    private String password;
    //10.1.170.207:17000,10.1.170.207:17001,10.1.170.207:17002,10.1.170.207:17003,10.1.170.207:17004,10.1.170.207:17005
    private static JedisPool pool = null;
    
    public static Jedis getRedis() {
    	return pool.getResource();
    }
    
//    public RedisOperation() {
//    	jedis = pool.getResource();
//    	jedis.close();
//    	System.out.println(jedis);
//    }
    

//    @PostConstruct
//    public void init() {
//    	
//    }
    
    /**
     * 从redis中获取数据
     * @param key
     * @return
     */
//    public String get(String key) {
//    	
//    	return jedis.get(key);
//    }
//    
//    /**
//     * 往redis中set数据
//     * @param key
//     * @param value
//     */
//    public void set(String key,String value) {
//    	jedis.set(key, value);
//    }
//    
//    /**
//     * 往redis中hset数据
//     * @param key
//     * @param field
//     * @param value
//     */
//    public void hset(String key,String field,String value) {
//    	jedis.hset(key, field, value);
//    }
//    
//    /**
//     * 从redis中hgetAll数据
//     * @param key
//     * @return
//     */
//    public Map<String,String> hgetAll(String key) {
//    	return jedis.hgetAll(key);
//    }
//    
//    public String hget(String key,String filed) {
//    	return jedis.hget(key,filed);
//    }
//    
//    public void hmset(String key,Map<String,String> hash) {
//    	jedis.hmset(key, hash);
//    }
//    /**
//     * 设置有效时间
//     * @param key
//     * @param second
//     */
//    public void expire(String key,int second) {
//    	jedis.expire(key, second);
//    }
//    
//    /**
//     * 往redis中存数据并且设置失效时间
//     * @param key
//     * @param seconds
//     * @param value
//     */
//    public void setex(String key,int seconds,String value) {
//    	jedis.setex(key, seconds, value);
//    }
//    
//    /**
//     * 批量获取指定的多个key的数据
//     * @param keys
//     * @return
//     */
//    public List<String> mget(String ...keys) {
//    	return jedis.mget(keys);
//    }
//    
//    /**
//     * 删除key
//     * @param key
//     */
//    public void del(String key) {
//    	jedis.del(key);
//    }
//    /**
//     * 判断key
//     * @param key
//     * @return
//     */
//    public boolean exists(String key) {
//    	return jedis.exists(key);
//    }
//    /**
//     * 释放资源
//     */
//    public void close() {
//    	try {
//    		if(jedis != null) {
//    			jedis.close();
//    		}
//			
//		} catch (Exception e) {
////			LOGGER.error("redis close fail={}",e.getMessage());
//		}
//    }

	@Override
	public void run(ApplicationArguments args) throws Exception {
		System.out.print("redis");
//		JedisPool pool = null;
    	// common-pool配置  
        if (pool == null) {
        	GenericObjectPoolConfig poolConfig = new GenericObjectPoolConfig();  
            poolConfig.setMaxTotal(GenericObjectPoolConfig.DEFAULT_MAX_TOTAL * 10);  
            poolConfig.setMaxIdle(GenericObjectPoolConfig.DEFAULT_MAX_IDLE * 4);  
            poolConfig.setMinIdle(GenericObjectPoolConfig.DEFAULT_MAX_IDLE * 2);
           
//             JedisPool.borrowObject最大等待时间  
            poolConfig.setMaxWaitMillis(1000L);
            try {
//                Set<HostAndPort> jedisClusterNodes = new HashSet<HostAndPort>();
//                String[] singleUrl = hostAndPort.trim().split(",");
                String[] single = hostAndPort.split(":");
//                for (int i = 0; i < singleUrl.length; i++) {
//                    String[] single = singleUrl[i].split(":");
//                    jedisClusterNodes.add(new HostAndPort(single[0],Integer.parseInt(single[1])));
////                    jedisClusterNodes.add(new HostAndPort(single[0], Integer.parseInt(single[1]), false));
//                }
//                jedis = new JedisCluster(jedisClusterNodes,2000,20);
//                jedis = new JedisCluster(jedisClusterNodes,1000,10,4,password,poolConfig);
//                new JedisPool(poolConfig, singleUrl[0], singleUrl[1],1000, password);
                pool= new JedisPool(poolConfig, single[0], Integer.parseInt(single[1]),1000, password);
            } catch (Exception e) {
            	e.printStackTrace();
            }
        }
		
	}
}